﻿using System;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            PrintAreaUsingLocalFunction();
            PrintAreaUsingStaticLocalFunction();
        }

        #endregion
        #region 로컬 함수를 사용해 영역 출력하기 - PrintAreaUsingLocalFunction()

        /// <summary>
        /// 로컬 함수를 사용해 영역 출력하기
        /// </summary>
        private static void PrintAreaUsingLocalFunction()
        {
            double radius = 1.0;

            PrintArea();

            radius = 2.0;

            PrintArea();

            // 로컬 함수
            void PrintArea()
            {
                double area = Math.PI * radius * radius;

                Console.WriteLine(area);
            }
        }

        #endregion
        #region 정적 로컬 함수를 사용해 영역 출력하기 - PrintAreaUsingStaticLocalFunction()

        /// <summary>
        /// 정적 로컬 함수를 사용해 영역 출력하기
        /// </summary>
        private static void PrintAreaUsingStaticLocalFunction()
        {
            double radius = 1.0;

            PrintArea(radius);

            radius = 2.0;

            PrintArea(radius);

            // 정적 로컬 함수
            static void PrintArea(double radius)
            {
                double area = Math.PI * radius * radius;

                Console.WriteLine(area);
            }
        }

        #endregion
    }
}